﻿
#target indesign

var curPage = app.activeWindow.activePage;
var pageItems = curPage.pageItems;
var textFrames = curPage.textFrames;

const gScriptName = "Export from InDesign to Photoshop"; // Name of the script
const gScriptVersion = "1.1"; // Version

var gDoc = app.activeDocument;
var gActPage = app.activeWindow.activePage;

var docPath = gDoc.filePath.absoluteURI + "/";
var gTempFolderPath = docPath + 'export/';
var gTempFolder = new Folder(gTempFolderPath);

if (!gTempFolder.exists) gTempFolder.create();

var myPageName = gActPage.name;    
app.pdfExportPreferences.pageRange = myPageName;

var pdfPresetName = "ExportToPS_bleedmarks";
var pdfPreset = app.pdfExportPresets.itemByName(pdfPresetName);
if (!pdfPreset.isValid) ErrorExit("Es muss noch eine Voreinstellung für den PDF-Export mit dem Namen \"" + pdfPresetName + "\" unter 'Datei > Adobe PDF Vorgaben' angelegt werden.", true);


 
 

function callPhotoshop(file) {  
        
    var bt = new BridgeTalk;  


    bt.target = "photoshop";
    bt.body = "\
        //app.displayDialogs = false;\
        app.documents.add("+curPage.bounds[3]+", "+curPage.bounds[2]+", 72, \"layout\", NewDocumentMode.RGB);\
   ";  

    SetDisplayDialogs("NO");
    bt.send();  
         
    pdfFileName = "Indesign Reference.pdf";
    pdfFilePath = gTempFolderPath + pdfFileName;
    pdfFile = new File(pdfFilePath);
    gDoc.exportFile(ExportFormat.PDF_TYPE, pdfFile, false, pdfPreset);

    PlacePDFinPSD( pdfFilePath );

    SetDisplayDialogs("YES");
}

function SetDisplayDialogs(mode) {
    var bt = new BridgeTalk;
    bt.target = "photoshop";
    var script = 'app.displayDialogs = DialogModes.' + mode + ';';
    bt.body = script;
    bt.send();
}

callPhotoshop();



function PlacePDFinPSD(filePath) {
    var bt = new BridgeTalk();
    bt.target = "photoshop";
    var script = PlacePdf.toString() + '\r';
    script += 'PlacePdf("' + filePath + '");';
    bt.body = script;
//~     $.write(script);
//~     exit();
    bt.onResult = function(resObj) {} 
    bt.onError = function(resObj) {
        alert(resObj.body);
    }
    bt.send(100);
}

//--------------------------------------------------------------------------------------------------------------------------------------------------------
function PlacePdf(filePath) {
    var idPlc = charIDToTypeID( "Plc " );
    var desc2 = new ActionDescriptor();
    var idAs = charIDToTypeID( "As  " );
    var desc3 = new ActionDescriptor();
    var idfsel = charIDToTypeID( "fsel" );
    var idpdfSelection = stringIDToTypeID( "pdfSelection" );
    var idpage = stringIDToTypeID( "page" );
    desc3.putEnumerated( idfsel, idpdfSelection, idpage );
    var idPgNm = charIDToTypeID( "PgNm" );
    desc3.putInteger( idPgNm, 1 );
    var idCrop = charIDToTypeID( "Crop" );
    var idcropTo = stringIDToTypeID( "cropTo" );
    var idcropBox = stringIDToTypeID( "cropBox" );
    desc3.putEnumerated( idCrop, idcropTo, idcropBox );
    var idPDFG = charIDToTypeID( "PDFG" );
    desc2.putObject( idAs, idPDFG, desc3 );
    var idnull = charIDToTypeID( "null" );
    desc2.putPath( idnull, new File( filePath ) );
    var idFTcs = charIDToTypeID( "FTcs" );
    var idQCSt = charIDToTypeID( "QCSt" );
    var idQcsa = charIDToTypeID( "Qcsa" );
    desc2.putEnumerated( idFTcs, idQCSt, idQcsa );
    var idOfst = charIDToTypeID( "Ofst" );
    var desc4 = new ActionDescriptor();
    var idHrzn = charIDToTypeID( "Hrzn" );
    var idRlt = charIDToTypeID( "#Rlt" );
    desc4.putUnitDouble( idHrzn, idRlt, 0.000000 );
    var idVrtc = charIDToTypeID( "Vrtc" );
    var idRlt = charIDToTypeID( "#Rlt" );
    desc4.putUnitDouble( idVrtc, idRlt, 0.000000 );
    var idOfst = charIDToTypeID( "Ofst" );
    desc2.putObject( idOfst, idOfst, desc4 );
    var idAntA = charIDToTypeID( "AntA" );
    desc2.putBoolean( idAntA, true );
    try {
        executeAction( idPlc, desc2, DialogModes.NO );
        //app.activeDocument.activeLayer.rasterize(RasterizeType.ENTIRELAYER);
    }
    catch(err) {
        $.writeln(err);
    }
}


function var_dump (obj) {
    var str = "";
    for (var j in obj) {
        str += j + "\n";
    }
    alert(str);
}

function SetDisplayDialogs(mode) {
    var bt = new BridgeTalk;
    bt.target = "photoshop";
    var script = 'app.displayDialogs = DialogModes.' + mode + ';';
    bt.body = script;
    bt.send();
}

function str_pad ( str ) {
    var str = "" + str;
    var pad = "000";
    return pad.substring(0, pad.length - str.length) + str; 
}

function ErrorExit(error, icon) {
    alert(error, gScriptName + " - " + gScriptVersion, icon);
    exit();
}
