﻿
//==================================================================

#target indesign
if (app.documents.length == 0) ErrorExit("Please open a document and try again.");

const gScriptName = "Export from InDesign to Photoshop"; // Name of the script
const gScriptVersion = "1.1"; // Version

var gUeberfuellung = 5;

var gDoc = app.activeDocument;
var gActPage = app.activeWindow.activePage;

var docPath = gDoc.filePath.absoluteURI + "/";


Main();

function Main() {

	var selectedItems = app.selection;
	if (!selectedItems.length) ErrorExit("Keine Elemente ausgewählt!");

	for (var i = 0; i < selectedItems.length; i++) {
		var item = selectedItems[i];
		
		var itemHeight = Math.ceil(item.visibleBounds[2]-item.visibleBounds[0]);
		var itemWidth = Math.ceil(item.visibleBounds[3]-item.visibleBounds[1]);

		var itemX = Math.floor(item.geometricBounds[1]);
		var itemY = Math.floor(item.geometricBounds[0]);

		item.geometricBounds = [itemY, itemX, itemY + itemHeight, itemX + itemWidth];
	}

}


function str_pad ( str ) {
	var str = "" + str;
	var pad = "000";
	return pad.substring(0, pad.length - str.length) + str;	
}

function ErrorExit(error, icon) {
	alert(error, gScriptName + " - " + gScriptVersion, icon);
	exit();
}


